using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Dimecasts.SOLID
{
    public class ReportPrinter
    {
        public virtual void Print()
        {
            DataAccess dataAccess = new DataAccess();
            ReportFormatter reportFormatter = new ReportFormatter();
            dataAccess.GetData();
            reportFormatter.FormatReport();
            Console.WriteLine("\nPrinting Report to laser printer...");
        }
    }


    public class TabloidReportPrinter : ReportPrinter
    {
        public override void Print()
        {
            DataAccess dataAccess = new DataAccess();
            ReportFormatter reportFormatter = new TabloidReportFormatter();
            dataAccess.GetData();
            reportFormatter.FormatReport();
            Console.WriteLine("\nPrinting Report to dot-matrix printer...");
            //base.Print();
        }
    }
}
